class Entity{constructor(){this.id=0;this.name="";this.attributes=[]}addAttribute(attr){if(attr!==null){attr.id=this.getMaxAttributeId()+1;this.attributes.push(attr)}}removeAttribute(id){this.attributes=this.attributes.filter(item=>item.id!=id)}getAttributes(){return[...this.attributes]}getAttributeById(id){let attr=null;let i=0;while(attr==null&&i<this.attributes.length){if(this.attributes[i].id==id){attr=this.attributes[i]}i++}return attr}getAttributeByName(name){let attr=null;let i=0;while(attr==null&&i<this.attributes.length){if(this.attributes[i].name==name){attr=this.attributes[i]}i++}return attr}getPrimaryKey(){let attr=null;let i=0;while(attr==null&&i<this.attributes.length){if(this.attributes[i].isPrimary){attr=this.attributes[i]}i++}return attr}getMaxAttributeId(){let max=0;for(let i=0;i<this.attributes.length;i++){if(this.attributes[i].id>max){max=this.attributes[i].id}}return max}}class Attribute{constructor(){this.id=0;this.pos=0;this.name="";this.type="";this.isPrimary=false;this.isForeign=false;this.isAutoIncrement=false;this.relations=[]}addRelation(rel){if(rel!==null){rel.id=this.getMaxRelationId()+1;this.relations.push(rel)}}removeRelation(id){this.relations=this.relations.filter(item=>item.id!=id)}getRelationById(id){let rel=null;let i=0;while(rel==null&&i<this.relations.length){if(this.relations[i].id==id){rel=this.relations[i]}i++}return rel}getMaxRelationId(){let max=0;for(let i=0;i<this.relations.length;i++){if(this.relations[i].id>max){max=this.relations[i].id}}return max}}class Relation{constructor(){this.id=0;this.ps=null;this.fs=null;this.psattr=null;this.fsattr=null;this.pscard=-1;this.fscard=-1}}class EntityManager{constructor(){this.entities=[];this.active=0;this.containerRect=document.querySelector("#ermcontainer").getBoundingClientRect();this.width=this.containerRect.width;this.height=this.containerRect.height;this.stage=new Konva.Stage({container:"ermcontainer",width:this.width,height:this.height});this.layer=new Konva.Layer({id:"layer_1"});this.setLayerBackground();this.stage.getContainer().style.backgroundColor="white";this.stage.add(this.layer)}getStageAsJson(){return this.stage.toJSON()}importStage(jsondata){this.stage.destroyChildren();this.stage=Konva.Node.create(jsondata,"ermcontainer");this.stage.getContainer().style.backgroundColor="white";this.layer=this.stage.findOne("#layer_1");this.updateCanvas(this.entities);for(let i=0;i<this.entities.length;i++){let group=this.stage.findOne("#group_"+this.entities[i].id);group.on("click tap",event=>{let id=event.target.attrs.id.substring(event.target.attrs.id.lastIndexOf("_")+1,event.target.attrs.id.length);let e=this.getEntityById(id);this.showEntity(e);this.updateCanvas([e])});group.on("dragmove",t=>{let id=t.target.attrs.id.substring(t.target.attrs.id.lastIndexOf("_")+1,t.target.attrs.id.length);this.updateEntityRelationLines(t.target.x(),t.target.y())})}}importEntities(entities){this.entities=[];for(let i=0;i<entities.length;i++){let entity=new Entity;entity.id=entities[i].id;entity.name=entities[i].name;entity.attributes=[];for(let a=0;a<entities[i].attributes.length;a++){let attribute=new Attribute;attribute.id=entities[i].attributes[a].id;attribute.name=entities[i].attributes[a].name;attribute.type=entities[i].attributes[a].type;attribute.pos=entities[i].attributes[a].pos;attribute.isPrimary=entities[i].attributes[a].isPrimary;attribute.isAutoIncrement=entities[i].attributes[a].isAutoIncrement;attribute.isForeign=entities[i].attributes[a].isForeign;attribute.relations=[];entity.attributes.push(attribute);for(let r=0;r<entities[i].attributes[a].relations.length;r++){let relation=new Relation;relation.id=entities[i].attributes[a].relations[r].id;relation.ps=entities[i].attributes[a].relations[r].ps;relation.fs=entities[i].attributes[a].relations[r].fs;relation.psattr=entities[i].attributes[a].relations[r].psattr;relation.fsattr=entities[i].attributes[a].relations[r].fsattr;relation.pscard=entities[i].attributes[a].relations[r].pscard;relation.fscard=entities[i].attributes[a].relations[r].fscard;attribute.relations.push(relation)}}this.entities.push(entity)}if(this.entities.length<=0){this.activeEntityChanged(0)}else{this.activeEntityChanged(1)}}redrawERM(){this.stage.destroyChildren();this.layer=new Konva.Layer({id:"layer_1"});this.setLayerBackground();this.stage.add(this.layer);this.updateCanvas(this.entities)}getEntities(){return[...this.entities]}addEntity(){let newentitiy=new Entity;newentitiy.id=this.getMaxEntityId()+1;newentitiy.name="Entity"+newentitiy.id;newentitiy.attributes=[];this.activeEntityChanged(newentitiy.id);this.entities.push(newentitiy);this.showEntity(newentitiy);this.updateCanvas([newentitiy]);return newentitiy}deleteEntity(){let entity=this.getActiveEntity();if(entity!==null){let relations=this.getRelation4Entity(entity);for(let r=0;r<relations.length;r++){this.removeRelation(relations[r].ps,relations[r].psattr,relations[r].id);this.removeEntityRelationLines(relations[r])}this.entities=this.entities.filter(item=>item.id!=entity.id);this.showEntity(null);let group=this.stage.findOne("#group_"+entity.id);if(group!=null){group.destroy();this.updateCanvas(this.entities)}}}addAttribute(){let entity=this.getActiveEntity();if(entity!==null){let attr=new Attribute;attr.name="?";attr.type="varchar";entity.addAttribute(attr);this.showEntity(entity);this.updateCanvas([entity])}}removeAttribute(id){let entity=this.getActiveEntity();if(entity!==null){let attribute=entity.getAttributeById(id);if(attribute!=null){let relations=this.getRelation4Entity(entity);if(relations!=null&&relations.length>0){for(let r=0;r<relations.length;r++){if(relations[r].ps==entity.id){this.removeRelation(entity.id,attribute.id,relations[r].id)}if(relations[r].fs==entity.id&&relations[r].fsattr==id){this.removeFSRelation(relations[r])}}}entity.removeAttribute(id);this.showEntity(entity);this.updateCanvas([entity])}}}updateName4ActiveEntity(newname){let entity=this.getActiveEntity();if(entity!==null&&newname.length>0){newname=newname.trim().replace(/\s/g,"").replace(/[^0-9a-z]/gi,"");newname=newname.charAt(0).toUpperCase()+newname.slice(1);entity.name=newname;this.showEntityRelations(entity);this.updateCanvas([entity])}}updateAttributename4ActiveEntity(attrid,newname){let entity=this.getActiveEntity();if(entity!==null){let attribute=entity.getAttributeById(attrid);if(attribute!=null){newname=newname.trim().replace(/\s/g,"").replace(/[^0-9a-z]/gi,"");newname=newname.toLowerCase();attribute.name=newname;this.showEntityRelations(entity);this.updateCanvas([entity])}}}updateAttributenPS4ActiveEntity(attrid,status){let entity=this.getActiveEntity();if(entity!==null){let attribute=entity.getAttributeById(attrid);if(attribute!=null){attribute.isPrimary=status;this.showEntityRelations(entity);this.updateCanvas([entity])}}}updateAttributenAI4ActiveEntity(attrid,status){let entity=this.getActiveEntity();if(entity!==null){let attribute=entity.getAttributeById(attrid);if(attribute!=null){attribute.isAutoIncrement=status;this.updateCanvas([entity])}}}updateAttributType4ActiveEntity(attrid,type){let entity=this.getActiveEntity();if(entity!==null){let attribute=entity.getAttributeById(attrid);if(attribute!=null){attribute.type=type;this.showEntityRelations(entity);this.updateCanvas([entity])}}}getRelations(){let relations=[];for(let e=0;e<this.entities.length;e++){for(let a=0;a<this.entities[e].attributes.length;a++){for(let r=0;r<this.entities[e].attributes[a].relations.length;r++){relations.push(this.entities[e].attributes[a].relations[r])}}}return relations}getRelation4Entity(entity){let relations=[];if(entity!=null){let rr=this.getRelations();for(let r=0;r<rr.length;r++){let relation=rr[r];if((relation.ps==entity.id||relation.fs==entity.id)&&relations.filter(r=>r.id==relation.id&&r.ps==relation.ps&&r.fs==relation.fs).length<=0){relations.push(relation)}}}return relations}addRelation(cardinality,targetentity){let entity=this.getActiveEntity();if(entity!==null){let relation=new Relation;let psentity=null;let fsentity=null;let pkattr=null;let fkattr=null;if(cardinality=="1:n"||cardinality=="n:m"){psentity=entity;fsentity=this.getEntityById(targetentity)}if(cardinality=="n:1"){psentity=this.getEntityById(targetentity);fsentity=entity}if(cardinality!="n:m"){pkattr=psentity.getPrimaryKey();if(fsentity.getAttributeByName(pkattr.name)!=null){fkattr=fsentity.getAttributeByName(pkattr.name);fkattr.isForeign=true}else{fkattr=new Attribute;fkattr.name=pkattr.name;fkattr.pos=0;fkattr.type=pkattr.type;fkattr.isPrimary=false;fkattr.isForeign=true;fkattr.relations=[];fsentity.addAttribute(fkattr)}relation.ps=psentity.id;relation.psattr=pkattr.id;relation.fs=fsentity.id;relation.fsattr=fkattr.id;relation.pscard="1";relation.fscard="n";pkattr.addRelation(relation);this.showEntity(entity);this.updateCanvas([fsentity]);this.updateCanvas([psentity])}if(cardinality=="n:m"){let newEntity=this.addEntity();let psattr=psentity.getPrimaryKey();let fsattr=fsentity.getPrimaryKey();newEntity.name=psentity.name+fsentity.name+"BezEntity";let attrPS=new Attribute;attrPS.name=newEntity.name.toLowerCase()+"nr";attrPS.type="int";attrPS.isPrimary=psattr.isPrimary=true;attrPS.isForeign=psattr.isForeign=false;newEntity.addAttribute(attrPS);let attr1=new Attribute;attr1.name=psattr.name;attr1.type=psattr.type;attr1.isPrimary=false;attr1.isForeign=true;newEntity.addAttribute(attr1);let attr2=new Attribute;attr2.name=fsattr.name;attr2.type=fsattr.type;attr2.isPrimary=false;attr2.isForeign=true;newEntity.addAttribute(attr2);let relation1=new Relation;relation1.ps=psentity.id;relation1.psattr=psattr.id;relation1.fs=newEntity.id;relation1.fsattr=attr1.id;relation1.pscard="1";relation1.fscard="n";psattr.addRelation(relation1);let relation2=new Relation;relation2.ps=fsentity.id;relation2.psattr=fsattr.id;relation2.fs=newEntity.id;relation2.fsattr=attr2.id;relation2.pscard="1";relation2.fscard="n";fsattr.addRelation(relation2);this.showEntity(newEntity);this.updateCanvas([newEntity,psentity,fsentity])}}}removeRelation(entityid,attributeid,relationid){let entityps=this.getEntityById(entityid);let attributeps=entityps.getAttributeById(attributeid);let relation=attributeps.getRelationById(relationid);attributeps.removeRelation(relationid);let entityfs=this.getEntityById(relation.fs);entityfs.removeAttribute(relation.fsattr);this.showEntity(this.getActiveEntity());this.removeEntityRelationLines(relation);this.updateCanvas([entityfs]);this.updateCanvas([entityps])}removeFSRelation(relation){let entityps=this.getEntityById(relation.ps);let entityfs=this.getEntityById(relation.fs);let attributeps=entityps.getAttributeById(relation.psattr);attributeps.removeRelation(relation.id);entityfs.removeAttribute(relation.fsattr);this.showEntity(this.getActiveEntity());this.removeEntityRelationLines(relation);this.updateCanvas([entityfs]);this.updateCanvas([entityps])}getActiveEntity(){return this.getEntityById(this.active)}getEntityById(id){let entity=null;let i=0;while(entity==null&&i<this.entities.length){if(this.entities[i].id==id){entity=this.entities[i]}i++}return entity}getMaxEntityId(){let max=0;for(let i=0;i<this.entities.length;i++){if(this.entities[i].id>max){max=this.entities[i].id}}return max}showEntity(entity){document.querySelector("#inputEntityName").innerText="";document.querySelector("#modellierungtab tbody").innerHTML="";if(entity!=null){this.activeEntityChanged(entity.id);document.querySelector("#inputEntityName").innerText=entity.name;document.querySelector("#modellierungtab tbody").innerHTML="";let html="";for(let i=0;i<entity.attributes.length;i++){let attribute=entity.attributes[i];html+='<tr class="handle eventhandler" data-attrid="'+attribute.id+'">';html+='\t<td scope="row" class="attributename" contenteditable>'+attribute.name+"</td>";html+="      <td>";html+='      \t<select class="form-select">';html+='\t\t  <option value="varchar" '+(attribute.type=="varchar"?"selected":"")+">varchar(n)</option>";html+='\t\t  <option value="int" '+(attribute.type=="int"?"selected":"")+">int</option>";html+='\t\t  <option value="double" '+(attribute.type=="double"?"selected":"")+">double</option>";html+='\t\t  <option value="date" '+(attribute.type=="date"?"selected":"")+">date</option>";html+='\t\t  <option value="time" '+(attribute.type=="time"?"selected":"")+">time</option>";html+='\t\t  <option value="boolean" '+(attribute.type=="boolean"?"selected":"")+">booelan</option>";html+="\t\t</select>";html+="      </td>";html+="      <td>";html+='\t\t<div class="form-check">';html+='\t\t  <input class="form-check-input" type="checkbox" id="flexCheckIsPrimary" '+(attribute.isPrimary?"checked":"")+">";html+="\t\t</div>";html+="      </td>";html+="      <td>";html+='\t\t<div class="form-check">';html+='\t\t  <input class="form-check-input" type="checkbox" id="flexCheckIsAutoIncrement" '+(attribute.isAutoIncrement?"checked":"")+">";html+="\t\t</div>";html+="     </td>";html+='     <td><i class="bi bi-trash"></i></td>';html+="</tr>";document.querySelector("#modellierungtab tbody").innerHTML=html;document.querySelectorAll(".eventhandler").forEach(eh=>{eh.addEventListener("click",event=>{let element=event.target.parentNode;while(element.tagName!="TR"){element=element.parentNode}if(event.target.id=="flexCheckIsPrimary"){this.updateAttributenPS4ActiveEntity(element.getAttribute("data-attrid"),event.target.checked)}else if(event.target.id=="flexCheckIsAutoIncrement"){this.updateAttributenAI4ActiveEntity(element.getAttribute("data-attrid"),event.target.checked)}else if(event.target.tagName=="SELECT"){this.updateAttributType4ActiveEntity(element.getAttribute("data-attrid"),event.target.value)}else if(event.target.className=="bi bi-trash"){this.removeAttribute(element.getAttribute("data-attrid"))}})});document.querySelectorAll(".attributename").forEach(eh=>{eh.addEventListener("input",event=>{let element=event.target.parentNode;while(element.tagName!="TR"){element=element.parentNode}this.updateAttributename4ActiveEntity(element.getAttribute("data-attrid"),event.target.innerText.trim().replace(/\s/g,"").replace(/[^0-9a-z]/gi,""))})});document.querySelectorAll(".attributename").forEach(eh=>{eh.addEventListener("keyup",event=>{if(event.code=="Enter"||event.key=="Enter"){eh.innerText=eh.innerText.trim().replace(/\s/g,"").replace(/[^0-9a-z]/gi,"");eh.blur();let element=event.target.parentNode;while(element.tagName!="TR"){element=element.parentNode}this.updateAttributename4ActiveEntity(element.getAttribute("data-attrid"),event.target.innerText.trim().replace(/\s/g,"").replace(/[^0-9a-z]/gi,""))}})});let el=document.querySelector("#modellierungtab");let dragger=tableDragger.default(el,{dragHandler:"#modellierungtab tr :nth-child(2), #modellierungtab tr :nth-child(3), #modellierungtab tr :nth-child(4)",mode:"row"});dragger.on("drop",this.resortAttributes.bind(this),null);var tooltipTriggerList=[].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'));var tooltipList=tooltipTriggerList.map(function(tooltipTriggerEl){return new bootstrap.Tooltip(tooltipTriggerEl)})}this.showEntityRelations(entity)}}showEntityRelations(entity){document.querySelector("#beziehungtab tbody").innerHTML="";if(entity!=null){this.activeEntityChanged(entity.id);document.querySelector("#beziehungtab tbody").innerHTML="";let html2="";let relations=this.getRelation4Entity(entity);for(let r=0;r<relations.length;r++){let relation=relations[r];html2+='  <tr class="eventhandler2" data-entityid="'+relation.ps+'" data-attrid="'+relation.psattr+'"  data-relid="'+relation.id+'">';html2+="  \t<td>"+entity.name+"</td>";html2+="  \t<td>";html2+='\t  \t<select class="form-select" aria-label="Relationtype" style="text-align: center;" disabled>';html2+="\t\t  <option></option>";html2+='\t\t  <option value="1:n" '+(relation.ps==entity.id?"selected":"")+">1 : n</option>";html2+='\t\t  <option value="n:1" '+(relation.fs==entity.id?"selected":"")+">n : 1</option>";html2+="\t\t</select>";html2+="  \t</td>";html2+="  \t<td>";html2+='  \t<select class="form-select" aria-label="RelationEntity2" style="text-align: center;" disabled>';for(let e=0;e<this.entities.length;e++){if(this.entities[e].id!=entity.id&&this.entities[e].getPrimaryKey()!=null){if(relation.ps==entity.id){html2+='\t\t  <option value="'+this.entities[e].id+'" '+(this.entities[e].id==relation.fs?"selected":"")+">"+this.entities[e].name+"</option>"}else{html2+='\t\t  <option value="'+this.entities[e].id+'" '+(this.entities[e].id==relation.ps?"selected":"")+">"+this.entities[e].name+"</option>"}}}html2+="\t\t</select>";html2+="  \t</td>";html2+='  \t<td><i class="bi bi-trash delrelation"></i></td>';html2+="  </tr>"}html2+='  <tr class="eventhandler2" data-attrid="0" data-relid="0">';html2+="  \t<td>"+entity.name+"</td>";html2+="  \t<td>";html2+='\t  \t<select id="cardSelector0" class="form-select" aria-label="Relationtype" style="text-align: center;">';html2+="\t\t  <option selected></option>";html2+='\t\t  <option value="1:n">1 : n</option>';html2+='\t\t  <option value="n:1">n : 1</option>';html2+='\t\t  <option value="n:m">n : m</option>';html2+="\t\t</select>";html2+="  \t</td>";html2+="  \t<td>";html2+='  \t<select id="entitySelector0" class="form-select" aria-label="RelationEntity2" style="text-align: center;">';html2+="\t\t  <option selected></option>";let entity2select=false;for(let e=0;e<this.entities.length;e++){if(this.entities[e].id!=entity.id&&this.entities[e].getPrimaryKey()!=null){entity2select=true;html2+='\t\t  <option value="'+this.entities[e].id+'">'+this.entities[e].name+"</option>"}}html2+="\t\t</select>";html2+="  \t</td>";html2+="  \t<td>"+(entity2select?'<i class="bi bi-plus-circle addrelation"></i>':"")+"</td>";html2+="  </tr>";document.querySelector("#beziehungtab tbody").innerHTML=html2;document.querySelectorAll(".eventhandler2").forEach(eh=>{eh.addEventListener("click",event=>{let element=event.target.parentNode;while(element.tagName!="TR"){element=element.parentNode}if(event.target.className=="bi bi-plus-circle addrelation"){this.addRelation(document.querySelector("#cardSelector0").value,document.querySelector("#entitySelector0").value)}else if(event.target.className=="bi bi-trash delrelation"){this.removeRelation(element.getAttribute("data-entityid"),element.getAttribute("data-attrid"),element.getAttribute("data-relid"))}})})}}updateCanvas(entities){for(let i=0;i<entities.length;i++){this.updateCanvasEntity(entities[i])}}activeEntityChanged(id){let rectActive=this.stage.findOne("#rect_"+this.active);if(rectActive!=null){rectActive.stroke("black")}let lineActive=this.stage.findOne("#line_"+this.active);if(lineActive!=null){lineActive.stroke("black")}this.active=id}setLayerBackground(){let rectBG=this.stage.findOne("#rect_bg");if(rectBG==null){rectBG=new Konva.Rect({id:"rect_bg",name:"rect_bg",x:0,y:0,width:this.stage.width(),height:this.stage.height(),fill:"white"});console.log("addRectBG");this.layer.add(rectBG)}}updateCanvasEntity(entity){let maxWidth=150;let maxHeight=100;let group=this.stage.findOne("#group_"+entity.id);if(group==null){group=new Konva.Group({id:"group_"+entity.id,name:"group_"+entity.id,draggable:true,entity:entity});group.on("click tap",event=>{let id=event.target.attrs.id.substring(event.target.attrs.id.lastIndexOf("_")+1,event.target.attrs.id.length);let e=this.getEntityById(id);this.showEntity(e);this.updateCanvas([e])});group.on("dragmove",t=>{this.updateEntityRelationLines(t.target.x(),t.target.y())});console.log("group");this.layer.add(group)}let titleText=null;let rect=this.stage.findOne("#rect_"+entity.id);if(rect==null){titleText=new Konva.Text({id:"textTitle_"+entity.id,name:"textTitle_"+entity.id,text:entity.name,fontSize:18,fontFamily:"Calibri",fontStyle:"bold",fill:"#555",padding:20,align:"left"});maxWidth=titleText.width();rect=new Konva.Rect({id:"rect_"+entity.id,name:"rect_"+entity.id,x:0,y:0,width:titleText.width(),height:150,stroke:"black",strokeWidth:2,fill:"white",shadowBlur:4,cornerRadius:2});group.add(rect);group.add(titleText)}let line=this.stage.findOne("#line_"+entity.id);if(line==null){line=new Konva.Line({id:"line_"+entity.id,name:"line_"+entity.id,points:[rect.x(),rect.y()+30,rect.x()+maxWidth,rect.y()+30],stroke:"#000",strokeWidth:2});group.add(line)}for(let a=0;a<100;a++){let attrText=this.stage.findOne("#attribute_"+a+"_"+entity.id);if(attrText!=null){attrText.destroy()}}if(entity.attributes&&entity.attributes.length){for(let a=0;a<entity.attributes.length;a++){let attribute=entity.attributes[a];let attrText=this.stage.findOne("#attribute_"+attribute.id+"_"+entity.id);if(attrText==null){attrText=new Konva.Text({id:"attribute_"+attribute.id+"_"+entity.id,name:"attribute_"+attribute.id+"_"+entity.id,x:rect.x(),y:a*20+28,text:attribute.name+"   "+attribute.type,fontSize:16,fontFamily:"Calibri",fontStyle:attribute.isPrimary?"bold":"normal",textDecoration:attribute.isPrimary?"underline":"normal",fill:"#555",padding:10,align:"left"});group.add(attrText);if(attrText.width()>maxWidth){maxWidth=attrText.width()}}else{attrText.text(attribute.name+"   "+attribute.type);attrText.textDecoration(attribute.isPrimary?"underline":"normal");if(attrText.width()>maxWidth){maxWidth=attrText.width()}}}this.updateEntityRelationLines(0,0)}if(titleText==null){titleText=this.stage.findOne("#textTitle_"+entity.id)}titleText.x(rect.x());titleText.y(rect.y()-12);titleText.text(entity.name);if(titleText.width()>maxWidth){maxWidth=titleText.width()}if(entity.attributes&&entity.attributes.length){maxHeight=60+18*entity.attributes.length>100?60+18*entity.attributes.length:100}rect.width(maxWidth);rect.height(maxHeight);line.points([rect.x(),rect.y()+30,rect.x()+maxWidth,rect.y()+30]);if(rect.id()=="rect_"+this.active){rect.stroke("blue");line.stroke("blue")}this.stage.draw()}removeEntityRelationLines(relation){let rgroup=this.stage.findOne("#rgroup_"+relation.psattr+"_"+relation.fsattr+"_"+relation.ps+"_"+relation.fs);if(rgroup!=null){rgroup.destroy()}}updateEntityRelationLines(x,y){let relations=this.getRelations();for(let r=0;r<relations.length;r++){let relation=relations[r];let rgroup=this.stage.findOne("#rgroup_"+relation.psattr+"_"+relation.fsattr+"_"+relation.ps+"_"+relation.fs);if(rgroup==null){rgroup=new Konva.Group({id:"rgroup_"+relation.psattr+"_"+relation.fsattr+"_"+relation.ps+"_"+relation.fs,name:"rgroup_"+relation.psattr+"_"+relation.fsattr+"_"+relation.ps+"_"+relation.fs,draggable:false});this.layer.add(rgroup)}let groupPS=this.stage.findOne("#group_"+relation.ps);let groupFS=this.stage.findOne("#group_"+relation.fs);let rectPS=this.stage.findOne("#rect_"+relation.ps);let rectFS=this.stage.findOne("#rect_"+relation.fs);let rellinePS=this.stage.findOne("#rellinePS_"+relation.psattr+"_"+relation.ps);if(rellinePS==null){rellinePS=new Konva.Line({id:"rellinePS_"+relation.psattr+"_"+relation.ps,name:"rellinePS_"+relation.psattr+"_"+relation.ps,points:[],stroke:"#000",strokeWidth:2});rgroup.add(rellinePS)}let rellineFS=this.stage.findOne("#rellineFS_"+relation.fsattr+"_"+relation.fs);if(rellineFS==null){rellineFS=new Konva.Line({id:"rellineFS_"+relation.fsattr+"_"+relation.fs,name:"rellineFS_"+relation.fsattr+"_"+relation.fs,points:[],stroke:"#000",strokeWidth:2});rgroup.add(rellineFS)}let relline=this.stage.findOne("#relline_"+relation.fsattr+"_"+relation.fs);if(relline==null){relline=new Konva.Line({id:"relline_"+relation.fsattr+"_"+relation.fs,name:"relline_"+relation.fsattr+"_"+relation.fs,points:[],stroke:"#000",strokeWidth:2});rgroup.add(relline)}let reltextPS=this.stage.findOne("#reltextPS_"+relation.psattr+"_"+relation.ps);if(reltextPS==null){reltextPS=new Konva.Text({id:"reltextPS_"+relation.psattr+"_"+relation.ps,name:"reltextPS_"+relation.psattr+"_"+relation.ps,text:relation.pscard,fontSize:12,fontFamily:"Calibri",fontStyle:"normal",textDecoration:"normal",fill:"#555",padding:2,align:"center"});rgroup.add(reltextPS)}let reltextFS=this.stage.findOne("#reltextFS_"+relation.fsattr+"_"+relation.fs);if(reltextFS==null){reltextFS=new Konva.Text({id:"reltextFS_"+relation.fsattr+"_"+relation.fs,name:"reltextFS_"+relation.fsattr+"_"+relation.fs,text:relation.fscard,fontSize:12,fontFamily:"Calibri",fontStyle:"normal",textDecoration:"normal",fill:"#555",padding:2,align:"center"});rgroup.add(reltextFS)}let attrPS=this.stage.findOne("#attribute_"+relation.psattr+"_"+relation.ps);let attrFS=this.stage.findOne("#attribute_"+relation.fsattr+"_"+relation.fs);if(groupPS&&groupFS){if(groupPS.x()+rectPS.width()/2<groupFS.x()){rellinePS.setAttr("points",[groupPS.x()+rectPS.width(),groupPS.y()+attrPS.y()+18,groupPS.x()+rectPS.width()+20,groupPS.y()+attrPS.y()+18]);rellineFS.setAttr("points",[groupFS.x()-20,groupFS.y()+attrFS.y()+18,groupFS.x(),groupFS.y()+attrFS.y()+18]);relline.setAttr("points",[groupPS.x()+rectPS.width()+20,groupPS.y()+attrPS.y()+18,groupFS.x()-20,groupFS.y()+attrFS.y()+18]);reltextPS.setAttr("x",groupPS.x()+rectPS.width()+6);reltextPS.setAttr("y",groupPS.y()+attrPS.y()+2);reltextFS.setAttr("x",groupFS.x()-16);reltextFS.setAttr("y",groupFS.y()+attrFS.y()+2)}else{rellinePS.setAttr("points",[groupPS.x()-20,groupPS.y()+attrPS.y()+18,groupPS.x(),groupPS.y()+attrPS.y()+18]);rellineFS.setAttr("points",[groupFS.x()+rectFS.width(),groupFS.y()+attrFS.y()+18,groupFS.x()+rectFS.width()+20,groupFS.y()+attrFS.y()+18]);relline.setAttr("points",[groupPS.x()-20,groupPS.y()+attrPS.y()+18,groupFS.x()+rectFS.width()+20,groupFS.y()+attrFS.y()+18]);reltextPS.setAttr("x",groupPS.x()-16);reltextPS.setAttr("y",groupPS.y()+attrPS.y()+2);reltextFS.setAttr("x",groupFS.x()+rectFS.width()+6);reltextFS.setAttr("y",groupFS.y()+attrFS.y()+2)}}}}exportERMasPNG(){let dataURL=this.stage.toDataURL({pixelRatio:3});let link=document.createElement("a");link.download="thommyERM-export.png";link.href=dataURL;document.body.appendChild(link);link.click();document.body.removeChild(link);link=null}exportERMasPDF(){let pdf=new jsPDF({orientation:"portrait",unit:"mm",format:"a4"});pdf.setFont("arial","normal");pdf.setFontSize(10);pdf.text("Erstellt am "+moment().format("DD.MM.YYYY HH:mm"),10,10);pdf.setFont("arial","normal");pdf.setFontSize(8);pdf.text("Thommy ERM",180,290);var image=this.stage.toImage({callback(img){pdf.addImage(img,"png",10,20,180,90);pdf.save("thommyERM-export.pdf")}})}resortAttributes(event){let entity=this.getActiveEntity();let i=0;document.querySelectorAll("#modellierungtab tr").forEach(tr=>{let attr=entity.getAttributeById(tr.getAttribute("data-attrid"));if(attr!=null){attr.pos=i;i++}});entity.attributes.sort((a,b)=>a.pos>b.pos?1:-1);this.updateCanvas([entity])}test(){let rect=new Konva.Rect({id:"rect_1",name:"rect_1",x:50,y:50,width:200,height:150,fill:"#fff",stroke:"black",strokeWidth:4,fill:"white",shadowBlur:4,cornerRadius:2,draggable:true});this.layer.add(rect);this.stage.draw()}}